################################################################################################
#
# Walking House
#
################################################################################################



################################################################# General ################################################################

scoreboard objectives add ET dummy
scoreboard objectives add snappable dummy
scoreboard objectives add rc minecraft.used:minecraft.carrot_on_a_stick
scoreboard objectives add sneak minecraft.custom:minecraft.sneak_time
scoreboard objectives add talk minecraft.custom:minecraft.talked_to_villager
scoreboard objectives add walk minecraft.custom:minecraft.walk_one_cm
scoreboard objectives add sprint minecraft.custom:minecraft.sprint_one_cm
scoreboard objectives add crouch minecraft.custom:minecraft.crouch_one_cm
scoreboard objectives add jump minecraft.custom:minecraft.jump
scoreboard objectives add anim_in dummy
scoreboard objectives add anim_out dummy
scoreboard objectives add house_state dummy
scoreboard objectives add ride_tp_mode dummy
scoreboard objectives add anim_state dummy
scoreboard objectives add is_moving dummy
scoreboard objectives add motion_toggle dummy
scoreboard objectives add leg_swing_timer dummy
scoreboard objectives add leg_swing dummy
scoreboard objectives add jump_timer dummy
scoreboard objectives add jump_rot dummy
scoreboard objectives add x dummy
scoreboard objectives add y dummy
scoreboard objectives add z dummy
scoreboard objectives add dx dummy
scoreboard objectives add dy dummy
scoreboard objectives add dz dummy
scoreboard objectives add walk_block dummy
scoreboard objectives add forward dummy
scoreboard objectives add jump_land dummy
scoreboard objectives add rotate_state dummy
scoreboard objectives add walk_toggle dummy
scoreboard objectives add tnt_cd dummy
scoreboard objectives add tnt_lt dummy
scoreboard objectives add jump_cd dummy
scoreboard objectives add controllable dummy
scoreboard objectives add rider_exit dummy
scoreboard objectives add was_rider dummy

tellraw @a[tag=!init_msg] ["",{"text":"\n\n\n==-=-- Minecraft Walking House - ","color":"red","bold":true},{"text":"by McMakistein","color":"gold","bold":true},{"text":" --=-==","color":"red","bold":true},{"text":"\n                        [","color":"none","bold":false},{"text":"Video about this creation","color":"dark_green","clickEvent":{"action":"open_url","value":"https://www.youtube.com/watch?v=ZWKPVcAmTyo"}},{"text":"]\n\n","color":"none"},{"text":"                       More of my work:\n","bold":true,"color":"none"},{"text":"                 [","bold":false,"color":"none"},{"text":"Youtube","color":"red","bold":true,"clickEvent":{"action":"open_url","value":"https://www.youtube.com/user/McMakistein?sub_confirmation=1."},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Subscribe for more commandblock creation like this!"}]}}},{"text":"] - [","color":"none","bold":false},{"text":"Twitter","color":"blue","bold":true,"clickEvent":{"action":"open_url","value":"https://twitter.com/MrMakistein"},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Follow me on twitter for updates and sneakpeaks on new projects!"}]}}},{"text":"] - [","color":"none","bold":false},{"text":"Instagram","color":"gold","bold":true,"clickEvent":{"action":"open_url","value":"http://instagram.com/mrmakistein"},"hoverEvent":{"action":"show_text","value":{"text":"","extra":[{"text":"Follow me on Instagram if you want to know more about me as a person!"}]}}},{"text":"]","color":"none","bold":false}]
tag @a add init_msg

gamerule logAdminCommands false
gamerule commandBlockOutput false
gamerule sendCommandFeedback false

##################################################################################### Walking House ################################################################################

#---------------------------------- Spawning & Killing -------------------------------------#


execute as @e[type=item,nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] at @s if block ~ ~-0.5 ~ chest{Items:[{Slot:3b,id:"minecraft:cobblestone_stairs",Count:1b},{Slot:4b,id:"minecraft:cobblestone_stairs",Count:1b},{Slot:5b,id:"minecraft:cobblestone_stairs",Count:1b},{Slot:12b,id:"minecraft:oak_planks",Count:10b},{Slot:13b,id:"minecraft:diamond_block",Count:1b},{Slot:14b,id:"minecraft:oak_planks",Count:10b},{Slot:21b,id:"minecraft:stone_bricks",Count:5b},{Slot:22b,id:"minecraft:stone_bricks",Count:5b},{Slot:23b,id:"minecraft:stone_bricks",Count:5b}]} run summon area_effect_cloud ~ ~ ~ {Tags:[house_spawn]}

execute as @e[tag=house_spawn] at @s run setblock ~ ~-0.5 ~ air
execute as @e[tag=house_spawn] at @s run kill @e[type=item,nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b},distance=..2]
execute as @e[tag=house_spawn] at @s run summon area_effect_cloud ~1 ~ ~ {Tags:[sp1]}
execute as @e[tag=house_spawn] at @s run execute as @a[distance=..2] at @s run tp @s ~ ~1 ~ 



execute at @e[tag=sp1] align xyz run execute as @e[tag=house,scores={house_state=0}] at @s run function walking_house:remove_house
execute at @e[tag=sp1] align xyz run execute as @e[tag=ride] at @s run data merge entity @s {DeathTime:19,Health:0}
execute at @e[tag=sp1] align xyz run kill @e[tag=house_as]
execute at @e[tag=sp1] align xyz run kill @e[tag=house]

execute at @e[tag=sp1] align xyz run summon armor_stand ~0.5 ~ ~ {Invisible:1,NoGravity:0,Tags:["house"],Marker:0,DisabledSlots:4144959,Pose:{Head:[0.001f,0.001f,0.001f]},Rotation:[90f]}
execute at @e[tag=sp1] align xyz run summon armor_stand ~0.5 ~1 ~ {Invisible:1,NoGravity:1,Tags:["pivot","house_as"],Marker:1,DisabledSlots:4144959,Pose:{Head:[0.001f,0.001f,0.001f]}}
execute at @e[tag=sp1] align xyz run summon pig ~-0.5 ~1 ~ {Silent:1b,Invulnerable:1b,NoAI:1b,Saddle:1b,Tags:["ride","invis"],ActiveEffects:[{Id:14b,Amplifier:1b,Duration:99,ShowParticles:0b}],Attributes:[{Name:generic.knockbackResistance,Base:9},{Name:generic.movementSpeed,Base:0}]}
execute at @e[tag=sp1] align xyz run function walking_house:set_house
kill @e[tag=sp1]
effect give @e[tag=invis] invisibility 99 9 true



execute as @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b}] at @s run execute as @e[tag=house,scores={house_state=0,anim_in=0,anim_out=0},distance=..3] at @s run summon area_effect_cloud ~ ~ ~ {Tags:[house_kill]}

execute as @e[tag=house_kill] at @s run kill @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b}]
execute as @e[tag=house_kill] at @s run function walking_house:remove_house
execute as @e[tag=house_kill] at @s run execute as @e[tag=ride] at @s run data merge entity @s {DeathTime:19,Health:0}
execute as @e[tag=house_kill] at @s run tag @p add give
execute as @e[tag=house_kill] at @s run kill @e[tag=house]

give @a[tag=give] minecraft:endermite_spawn_egg{display:{Name:"{\"text\":\"§6§lWalking House\"}",Lore:["Rightclick to spawn."]},EntityTag:{id:"minecraft:armor_stand",Invisible:1,Marker:1,Tags:["sp1","sp"]},HideFlags:63}


#---------------------------------- 3rd Person Controller -------------------------------------#

scoreboard players add @e[tag=house] ride_tp_mode 0

execute as @e[tag=house,scores={ride_tp_mode=1}] at @s run execute as @e[tag=house_body] at @s run tp @e[tag=pivot,limit=1,sort=nearest] ~ ~-4 ~ 
#
#

execute as @e[tag=house,scores={ride_tp_mode=1}] at @s run tp @e[tag=ride,limit=1,sort=nearest] ~-0.5 ~1 ~ 
execute as @e[tag=house,scores={ride_tp_mode=1}] at @s run execute as @e[tag=pivot,limit=1,sort=nearest] run execute store result entity @s Rotation[0] float 1 run data get entity @p[tag=rider] Rotation[0] 1
execute as @e[tag=house,scores={ride_tp_mode=1}] at @s run execute as @e[tag=pivot,limit=1,sort=nearest] run execute store result entity @s Rotation[1] float 1 run data get entity @p[tag=rider] Rotation[1] 1
execute as @e[tag=house,scores={ride_tp_mode=1}] at @s run execute as @e[tag=pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-15 run tp @e[tag=ride] ~ ~ ~ 


#---------------------------------- Animation Controller -------------------------------------#
tag @a remove rider
tag @a[nbt={RootVehicle:{Entity:{id:"minecraft:pig",Tags:["ride"]}}}] add rider
execute as @a[tag=rider] at @s run scoreboard players set @e[tag=house,scores={house_state=0,anim_in=0,anim_out=0}] anim_in 1


execute as @e[tag=house,scores={anim_out=0,anim_in=0,house_state=0}] at @s run execute at @e[tag=ride] run particle portal ~ ~0.8 ~ 0 0 0 0.2 1 force
execute as @e[tag=house,scores={anim_out=0,anim_in=0,house_state=0}] at @s run execute at @e[tag=ride] run particle enchant ~ ~0.8 ~ 0.1 0.1 0.1 0.2 1 force

scoreboard players add @e[tag=house,scores={house_state=1,anim_in=0,anim_out=0}] rider_exit 1
execute as @a[tag=rider] at @s run scoreboard players set @e[tag=house] rider_exit 0

scoreboard players set @e[tag=house,scores={rider_exit=3..}] anim_out 1
execute as @e[tag=house,scores={rider_exit=3..}] run tag @a[scores={was_rider=1..}] add clear_chat
scoreboard players set @e[tag=house,scores={rider_exit=3..}] rider_exit 0


scoreboard players add @a was_rider 0
scoreboard players remove @a[scores={was_rider=1..}] was_rider 1
scoreboard players set @a[tag=rider] was_rider 100

effect give @a[tag=rider] minecraft:resistance 3 199 true
effect give @a[tag=rider] minecraft:invisibility 1 2 true

#---------------------------------- Transform Animation In -------------------------------------#

scoreboard players add @e[tag=house] controllable 0
scoreboard players add @e[tag=house] anim_in 0
scoreboard players add @e[tag=house,scores={anim_in=1..}] anim_in 1
scoreboard players set @e[tag=house,scores={anim_in=100}] anim_state 1
scoreboard players set @e[tag=house,scores={anim_in=100}] controllable 1
execute as @e[tag=house,scores={anim_in=100}] at @s run tag @a[tag=rider] add control_panel
scoreboard players set @e[tag=house,scores={anim_in=1..}] house_state 1
scoreboard players set @e[tag=house,scores={anim_in=1..5}] ride_tp_mode 1

execute as @e[tag=house,scores={anim_in=2}] at @s run function walking_house:remove_house
execute as @e[tag=house,scores={anim_in=2}] at @s run summon armor_stand ~ ~2 ~ {Invisible:1,NoGravity:1,Tags:["house_body","house_as","house_rot"],Marker:0,DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:2},Count:1b}],Rotation:[90f],Pose:{Head:[0.001f,0.001f,0.001f]}}
execute as @e[tag=house,scores={anim_in=2}] at @s run summon armor_stand ~ ~4.8 ~ {Invisible:1,NoGravity:1,Tags:["house_legA","house_as","leg","house_rot"],Marker:0,DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:3},Count:1b}],Rotation:[90f],Pose:{Head:[0.001f,0.001f,0.001f]}}
execute as @e[tag=house,scores={anim_in=2}] at @s run summon armor_stand ~ ~4.8 ~ {Invisible:1,NoGravity:1,Tags:["house_legB","house_as","leg","house_rot"],Marker:0,DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:6},Count:1b}],Rotation:[90f],Pose:{Head:[0.001f,0.001f,0.001f]}}

#execute as @e[tag=house,scores={anim_in=2}] at @s run summon armor_stand ~ ~0.5 ~-1 {Invisible:1,NoGravity:1,Tags:["house_armA","house_as","arm","house_rot"],Marker:0,DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:9},Count:1b}],Rotation:[90f],Pose:{Head:[0.001f,0.001f,0.001f]}}
#execute as @e[tag=house,scores={anim_in=2}] at @s run summon armor_stand ~ ~0.5 ~1 {Invisible:1,NoGravity:1,Tags:["house_armB","house_as","arm","house_rot"],Marker:0,DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:10},Count:1b}],Rotation:[90f],Pose:{Head:[0.001f,0.001f,0.001f]}}

execute as @e[tag=house,scores={anim_in=2}] at @s run summon armor_stand ~ ~0.5 ~1.5 {Invisible:1,NoGravity:1,Tags:["house_armA","house_as","arm","house_rot"],Marker:0,DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:11},Count:1b}],Rotation:[90f],Pose:{Head:[0.001f,0.001f,0.001f]}}
execute as @e[tag=house,scores={anim_in=2}] at @s run summon armor_stand ~ ~0.5 ~-1.5 {Invisible:1,NoGravity:1,Tags:["house_armB","house_as","arm","house_rot"],Marker:0,DisabledSlots:4144959,ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:11},Count:1b}],Rotation:[90f],Pose:{Head:[0.001f,0.001f,0.001f]}}


execute as @e[tag=house,scores={anim_in=61..100}] at @s run execute as @e[tag=house_body] at @s run tp @s ~ ~0.15 ~ 
execute as @e[tag=house,scores={anim_in=61..100}] at @s run execute as @e[tag=arm] at @s run tp @s ~ ~0.15 ~ 
execute as @e[tag=house,scores={anim_in=41..50}] at @s run execute as @e[tag=house_armA] at @s run tp @s ~ ~ ~0.1 
execute as @e[tag=house,scores={anim_in=41..50}] at @s run execute as @e[tag=house_armB] at @s run tp @s ~ ~ ~-0.1 

scoreboard players set @e[tag=house,scores={anim_in=5}] anim_in 37
execute as @e[tag=house,scores={anim_in=81}] at @s run execute as @e[tag=house_legA] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:4},Count:1b}]}
execute as @e[tag=house,scores={anim_in=100}] at @s run execute as @e[tag=house_legA] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:5},Count:1b}]}

execute as @e[tag=house,scores={anim_in=81}] at @s run execute as @e[tag=house_legB] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:7},Count:1b}]}
execute as @e[tag=house,scores={anim_in=100}] at @s run execute as @e[tag=house_legB] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:8},Count:1b}]}

scoreboard players set @e[tag=house,scores={anim_in=100..}] anim_in 0


#---------------------------------- Transform Animation Out -------------------------------------#

scoreboard players add @e[tag=house] anim_out 0
scoreboard players set @e[tag=house,scores={anim_out=1..}] is_moving 0
scoreboard players set @e[tag=house,scores={anim_out=1..}] forward 0
scoreboard players add @e[tag=house,scores={anim_out=1..}] anim_out 1
scoreboard players set @e[tag=house,scores={anim_out=2}] controllable 1
scoreboard players set @e[tag=house,scores={anim_out=170..}] anim_out 0
scoreboard players set @e[tag=house,scores={anim_out=2}] anim_state 0
scoreboard players set @e[tag=house,scores={anim_out=1..}] house_state 0
scoreboard players set @e[tag=house,scores={anim_out=138..}] ride_tp_mode 0


execute as @e[tag=house,scores={anim_out=3}] at @s run tag @a[tag=rider] add clear_chat
execute as @e[tag=leg,scores={leg_swing=0}] at @s run scoreboard players set @e[tag=house,scores={anim_out=5..58}] anim_out 59
scoreboard players set @e[tag=house,scores={anim_out=2..3,jump_land=1..}] anim_out 2
execute as @e[tag=house,scores={anim_out=5}] at @s run tag @a[tag=rider] add clear_chat

execute as @e[tag=house,scores={anim_out=4}] at @s align xyz positioned ~0.5 ~ ~ run tp @s ~ ~ ~ 

execute as @e[tag=house,scores={anim_out=60}] at @s run tp @s ~ ~ ~ 90 0
execute as @e[tag=house,scores={anim_out=60}] at @s run execute as @e[tag=house_rot] at @s run execute store result entity @s Rotation[0] float 1 run data get entity @e[tag=house,limit=1,sort=nearest] Rotation[0] 1 
execute as @e[tag=house,scores={anim_out=60}] at @s positioned ~ ~8 ~ run tp @e[tag=house_body,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=house,scores={anim_out=60}] at @s positioned ~ ~4.8 ~ run tp @e[tag=leg] ~ ~ ~
execute as @e[tag=house,scores={anim_out=60}] at @s positioned ^2.5 ^6.5 ^ run tp @e[tag=house_armA,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=house,scores={anim_out=60}] at @s positioned ^-2.5 ^6.5 ^ run tp @e[tag=house_armB,limit=1,sort=nearest] ~ ~ ~

execute as @e[tag=house,scores={anim_out=71..110}] at @s run execute as @e[tag=house_body] at @s run tp @s ~ ~-0.15 ~ 
execute as @e[tag=house,scores={anim_out=71..110}] at @s run execute as @e[tag=arm] at @s run tp @s ~ ~-0.15 ~ 
execute as @e[tag=house,scores={anim_out=121..130}] at @s run execute as @e[tag=house_armA] at @s run tp @s ~ ~ ~-0.1 
execute as @e[tag=house,scores={anim_out=121..130}] at @s run execute as @e[tag=house_armB] at @s run tp @s ~ ~ ~0.1 
execute as @e[tag=house,scores={anim_out=100}] at @s run tag @a[tag=rider] add clear_chat


execute as @e[tag=house,scores={anim_out=91}] at @s run execute as @e[tag=house_legA] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:3},Count:1b}]}
execute as @e[tag=house,scores={anim_out=110}] at @s run execute as @e[tag=house_legA] at @s run data merge entity @s {ArmorItems:[{},{},{},{}]}

execute as @e[tag=house,scores={anim_out=91}] at @s run execute as @e[tag=house_legB] at @s run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:6},Count:1b}]}
execute as @e[tag=house,scores={anim_out=110}] at @s run execute as @e[tag=house_legB] at @s run data merge entity @s {ArmorItems:[{},{},{},{}]}




execute as @e[tag=house,scores={anim_out=140}] at @s run function walking_house:set_house
execute as @e[tag=house,scores={anim_out=140}] at @s run kill @e[tag=house_body]
execute as @e[tag=house,scores={anim_out=140}] at @s run kill @e[tag=leg]
execute as @e[tag=house,scores={anim_out=140}] at @s run kill @e[tag=arm]
execute as @e[tag=house,scores={anim_out=140}] at @s run tp @e[tag=ride] ~-0.5 ~1 ~
execute as @e[tag=house,scores={anim_out=140}] at @s run tp @a[tag=rider] ~-0.5 ~1 ~
execute as @e[tag=house,scores={anim_out=142..}] at @s run tp @a[tag=rider] ~ ~ ~



#---------------------------------- Walking Animation -------------------------------------#

scoreboard players add @e[tag=house] house_state 0
scoreboard players add @e[tag=house] anim_state 0

execute as @e[tag=house,scores={anim_state=1}] at @s run execute as @e[tag=house_rot] at @s run execute store result entity @s Rotation[0] float 1 run data get entity @e[tag=house,limit=1,sort=nearest] Rotation[0] 1 
execute as @e[tag=house,scores={anim_state=1}] at @s positioned ~ ~8 ~ run tp @e[tag=house_body,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=house,scores={anim_state=1}] at @s positioned ~ ~4.8 ~ run tp @e[tag=leg] ~ ~ ~
execute as @e[tag=house,scores={anim_state=1}] at @s positioned ^2.5 ^6.5 ^ run tp @e[tag=house_armA,limit=1,sort=nearest] ~ ~ ~
execute as @e[tag=house,scores={anim_state=1}] at @s positioned ^-2.5 ^6.5 ^ run tp @e[tag=house_armB,limit=1,sort=nearest] ~ ~ ~

#Movement Transition

execute as @e[tag=house,scores={is_moving=0}] run scoreboard players set @e[tag=house_as] is_moving 0
execute as @e[tag=house,scores={is_moving=1}] run scoreboard players set @e[tag=house_as] is_moving 1


scoreboard players set @e[tag=house,scores={is_moving=0,motion_toggle=..0}] motion_toggle 0
scoreboard players set @e[tag=house,scores={is_moving=1,motion_toggle=0..}] motion_toggle 0

scoreboard players add @e[tag=house,scores={is_moving=0}] motion_toggle 1
scoreboard players remove @e[tag=house,scores={is_moving=1}] motion_toggle 1
scoreboard players operation @e[tag=leg] motion_toggle = @e[tag=house] motion_toggle
scoreboard players operation @e[tag=leg] is_moving = @e[tag=house] is_moving


#Swing

scoreboard players add @e[tag=leg] leg_swing 0
scoreboard players add @e[tag=leg] right_swing 0

scoreboard players set @e[tag=house_legA,scores={motion_toggle=-2}] leg_swing_timer 1
scoreboard players set @e[tag=house_legB,scores={motion_toggle=-2}] leg_swing_timer 27

scoreboard players add @e[tag=leg] leg_swing_timer 0
scoreboard players add @e[tag=leg,scores={leg_swing_timer=1..,is_moving=1}] leg_swing_timer 1

scoreboard players set @e[tag=leg,scores={leg_swing_timer=54..}] leg_swing_timer 1

scoreboard players remove @e[tag=leg,scores={leg_swing=10..,is_moving=0}] leg_swing 1
scoreboard players add @e[tag=leg,scores={leg_swing=..-10,is_moving=0}] leg_swing 1
scoreboard players remove @e[tag=leg,scores={leg_swing=1..,is_moving=0}] leg_swing 1
scoreboard players add @e[tag=leg,scores={leg_swing=..-1,is_moving=0}] leg_swing 1


scoreboard players set @e[tag=leg,scores={is_moving=1,leg_swing_timer=1}] leg_swing 0
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=2..5}] leg_swing 3
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=6..10}] leg_swing 2
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=11..15}] leg_swing 1
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=16..20}] leg_swing 1
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=21..25}] leg_swing 2
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=26..33}] leg_swing 3
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=34..38}] leg_swing 2
scoreboard players remove @e[tag=leg,scores={is_moving=1,leg_swing_timer=39..43}] leg_swing 1
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=44..48}] leg_swing 2
scoreboard players add @e[tag=leg,scores={is_moving=1,leg_swing_timer=49..53}] leg_swing 3

scoreboard players operation @e[tag=house_armB] leg_swing = @e[tag=house_legB] leg_swing
scoreboard players operation @e[tag=house_armA] leg_swing = @e[tag=house_legA] leg_swing


execute as @e[tag=leg] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s leg_swing
execute as @e[tag=arm] at @s run execute store result entity @s Pose.Head[0] float 1 run scoreboard players get @s leg_swing


#---------------------------------- Jump Animation -------------------------------------#

scoreboard players add @e[tag=house] jump_cd 0
scoreboard players add @e[tag=house,scores={jump_cd=1..}] jump_cd 1
execute as @e[tag=house,scores={jump_cd=30..}] at @s run tag @a[tag=rider] add control_panel
scoreboard players set @e[tag=house,scores={jump_cd=30..}] jump_cd 0


scoreboard players set @e[tag=house,scores={jump_cd=2}] jump_timer 1

scoreboard players add @e[tag=house] jump_land 0
scoreboard players add @e[tag=house] jump_timer 0
scoreboard players add @e[tag=house] jump_rot 0
scoreboard players set @e[tag=house,scores={jump_timer=1..23}] jump_land 1
scoreboard players add @e[tag=house,scores={jump_timer=1..}] jump_timer 1
scoreboard players set @e[tag=house,scores={jump_timer=25..}] jump_timer 0

scoreboard players add @e[tag=house,scores={jump_timer=1..2}] jump_rot 1
scoreboard players add @e[tag=house,scores={jump_timer=3..4}] jump_rot 5
scoreboard players add @e[tag=house,scores={jump_timer=5..6}] jump_rot 14
scoreboard players add @e[tag=house,scores={jump_timer=7..9}] jump_rot 5
scoreboard players remove @e[tag=house,scores={jump_timer=12..14}] jump_rot 3
scoreboard players remove @e[tag=house,scores={jump_timer=15..20}] jump_rot 6
scoreboard players remove @e[tag=house,scores={jump_timer=21..23}] jump_rot 3
scoreboard players set @e[tag=house,scores={jump_timer=24}] jump_rot 0

scoreboard players operation @e[tag=house_armB] jump_rot = @e[tag=house] jump_rot
scoreboard players set @e[tag=house_armA] jump_rot 0
scoreboard players operation @e[tag=house_armA] jump_rot -= @e[tag=house] jump_rot

execute as @e[tag=house,scores={jump_timer=1..}] run execute as @e[tag=house_armB] at @s run execute store result entity @s Pose.Head[2] float 1 run scoreboard players get @s jump_rot
execute as @e[tag=house,scores={jump_timer=1..}] run execute as @e[tag=house_armA] at @s run execute store result entity @s Pose.Head[2] float 1 run scoreboard players get @s jump_rot

execute as @e[tag=house,scores={jump_timer=3,forward=0}] at @s run data merge entity @s {Motion:[0.0,0.7,0.0]}
execute as @e[tag=house,scores={jump_timer=3,forward=1}] at @s run function walking_house:jump

execute as @e[tag=house,scores={jump_land=1}] at @s unless block ~ ~-0.3 ~ air run scoreboard players set @s jump_land 0


#---------------------------------- Tnt Attack -------------------------------------#
scoreboard players add @e[tag=house] tnt_cd 0
scoreboard players add @e[tag=house,scores={tnt_cd=1..}] tnt_cd 1
execute as @e[tag=house,scores={tnt_cd=10..}] at @s run tag @a[tag=rider] add control_panel
scoreboard players set @e[tag=house,scores={tnt_cd=10..}] tnt_cd 0

execute as @e[tag=house,scores={tnt_cd=2,anim_out=0}] at @s run function walking_house:launch_tnt

scoreboard players add @e[tag=tnt_proj] tnt_lt 1
kill @e[tag=tnt_proj,scores={tnt_lt=100..}]

execute as @e[tag=tnt_proj,scores={tnt_lt=3..},nbt={OnGround:1b}] at @s run summon tnt ~ ~ ~ 
kill @e[tag=tnt_proj,scores={tnt_lt=3..},nbt={OnGround:1b}]






#---------------------------------- Walking -------------------------------------#

execute as @e[tag=house,scores={rotate_state=-1,jump_timer=0,anim_out=0,jump_timer=0,jump_land=0}] at @s run tp @s ~ ~ ~ ~-2 0
execute as @e[tag=house,scores={rotate_state=1,jump_timer=0,anim_out=0,jump_timer=0,jump_land=0}] at @s run tp @s ~ ~ ~ ~2 0

scoreboard players set @e[tag=house] walk_block 0
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 air run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 cave_air run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 void_air run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 grass run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 tall_grass run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 powered_rail run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 detector_rail run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 rail run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 activator_rail run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 fern run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 dead_bush run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 dandelion run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 poppy run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 blue_orchid run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 allium run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 azure_bluet run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 red_tulip run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 orange_tulip run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 white_tulip run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 pink_tulip run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 oxeye_daisy run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 cornflower run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 lily_of_the_valley run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 wither_rose run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 brown_mushroom run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 red_mushroom run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 torch run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 vine run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 lilac run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 rose_bush run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 peony run scoreboard players set @s walk_block 1
execute as @e[tag=house,scores={forward=1..}] at @s if block ^ ^ ^-0.5 large_fern run scoreboard players set @s walk_block 1


execute as @e[tag=house,scores={forward=1..,walk_block=0}] at @s if block ^ ^1 ^-0.5 air run scoreboard players set @s walk_block 2
execute as @e[tag=house,scores={forward=1..,walk_block=0}] at @s if block ^ ^1 ^-0.5 grass run scoreboard players set @s walk_block 2
execute as @e[tag=house,scores={forward=1..,walk_block=0}] at @s if block ^ ^1 ^-0.5 cave_air run scoreboard players set @s walk_block 2
execute as @e[tag=house,scores={forward=1..,walk_block=0}] at @s if block ^ ^1 ^-0.5 void_air run scoreboard players set @s walk_block 2
execute as @e[tag=house,scores={forward=1..,walk_block=0}] at @s if block ^ ^1 ^-0.5 tall_grass run scoreboard players set @s walk_block 2

scoreboard players set @e[tag=house,scores={jump_timer=1..}] walk_block 0
scoreboard players set @e[tag=house,scores={jump_land=1}] walk_block 0

#scoreboard players set @e[tag=house] walk_block 0
#scoreboard players set @e[tag=house] walk_block 0

scoreboard players set @e[tag=house,scores={walk_block=1..,anim_out=0}] is_moving 1
scoreboard players set @e[tag=house,scores={walk_block=0,anim_out=0}] is_moving 0

execute as @e[tag=house,scores={forward=1..,walk_block=1,anim_out=0}] at @s run function walking_house:walk 
execute as @e[tag=house,scores={forward=1..,walk_block=2,anim_out=0}] at @s run function walking_house:walk_up


#---------------------------------- Control Panel -------------------------------------#

scoreboard players add @e[tag=house] rotate_state 0
scoreboard players add @e[tag=house] forward 0

scoreboard players set @e[tag=rotate_left] rotate_state -1
scoreboard players set @e[tag=rotate_stop] rotate_state 0
scoreboard players set @e[tag=rotate_right] rotate_state 1
scoreboard players set @e[tag=exit] anim_out 1
execute as @e[tag=exit] run tag @a[tag=rider] add clear_chat

scoreboard players set @e[tag=activate_jump,scores={jump_cd=0}] jump_cd 1
scoreboard players set @e[tag=activate_shoot,scores={tnt_cd=0}] tnt_cd 1


scoreboard players add @e[tag=walk_toggle] forward 1
scoreboard players set @e[tag=walk_toggle,scores={forward=2..}] forward 0

execute as @e[tag=rotate_left] at @s run tag @a[tag=rider] add control_panel
execute as @e[tag=rotate_right] at @s run tag @a[tag=rider] add control_panel
execute as @e[tag=rotate_stop] at @s run tag @a[tag=rider] add control_panel
execute as @e[tag=walk_toggle] at @s run tag @a[tag=rider] add control_panel
execute as @e[tag=activate_jump] at @s run tag @a[tag=rider] add control_panel
execute as @e[tag=activate_shoot] at @s run tag @a[tag=rider] add control_panel

tag @e[tag=rotate_left] remove rotate_left
tag @e[tag=rotate_right] remove rotate_right
tag @e[tag=rotate_stop] remove rotate_stop
tag @e[tag=walk_toggle] remove walk_toggle
tag @e[tag=activate_jump] remove activate_jump
tag @e[tag=activate_shoot] remove activate_shoot
tag @e[tag=exit] remove exit


tellraw @a[tag=control_panel] ["",{"text":"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n==- Walking House Control Panel ","color":"red","bold":true},{"text":"-==\n\n          ","color":"red","bold":true}]

execute as @e[tag=house,scores={forward=1}] at @s run tellraw @a[tag=control_panel] ["",{"text":"                      ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add walk_toggle"}},{"text":"▲","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add walk_toggle"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add walk_toggle"},"color":"none","bold":false},{"text":"\n","color":"none"}]

execute as @e[tag=house,scores={forward=0}] at @s run tellraw @a[tag=control_panel] ["",{"text":"                      ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add walk_toggle"}},{"text":"▲","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add walk_toggle"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add walk_toggle"},"color":"none","bold":false},{"text":"\n","color":"none"}]

execute as @e[tag=house,scores={rotate_state=-1}] at @s run tellraw @a[tag=control_panel]  ["",{"text":"              ","color":"none"},{"text":" [","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"},"color":"none","bold":false},{"text":"<","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"},"color":"none"},{"text":"X","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"},"color":"none"},{"text":">","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"},"color":"none","bold":false}]

execute as @e[tag=house,scores={rotate_state=0}] at @s run tellraw @a[tag=control_panel]  ["",{"text":"              ","color":"none"},{"text":" [","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"},"color":"none","bold":false},{"text":"<","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"},"color":"none"},{"text":"X","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"},"color":"none"},{"text":">","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"},"color":"none","bold":false}]

execute as @e[tag=house,scores={rotate_state=1}] at @s run tellraw @a[tag=control_panel]  ["",{"text":"              ","color":"none"},{"text":" [","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"},"color":"none","bold":false},{"text":"<","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_left"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"},"color":"none"},{"text":"X","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_stop"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"},"color":"none"},{"text":">","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add rotate_right"},"color":"none","bold":false}]

execute as @e[tag=house,scores={jump_cd=0,tnt_cd=0}] at @s run tellraw @a[tag=control_panel]  ["",{"text":"\n             "},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"Jump","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none"},{"text":"Shoot","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none","bold":false},{"text":"\n","color":"none"}]

execute as @e[tag=house,scores={jump_cd=0,tnt_cd=1..}] at @s run tellraw @a[tag=control_panel]  ["",{"text":"\n             "},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"Jump","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none"},{"text":"Shoot","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none","bold":false},{"text":"\n","color":"none"}]

execute as @e[tag=house,scores={jump_cd=1..,tnt_cd=0}] at @s run tellraw @a[tag=control_panel]  ["",{"text":"\n             "},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"Jump","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none"},{"text":"Shoot","color":"green","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none","bold":false},{"text":"\n","color":"none"}]

execute as @e[tag=house,scores={jump_cd=1..,tnt_cd=1..}] at @s run tellraw @a[tag=control_panel]  ["",{"text":"\n             "},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"Jump","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_jump"},"color":"none","bold":false},{"text":" - ","color":"none"},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none"},{"text":"Shoot","color":"dark_gray","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add activate_shoot"},"color":"none","bold":false},{"text":"\n","color":"none"}]

tellraw @a[tag=control_panel]  ["",{"text":"                    "},{"text":"[","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add exit"}},{"text":"Exit","color":"red","bold":true,"clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add exit"}},{"text":"]","clickEvent":{"action":"run_command","value":"/tag @e[tag=house] add exit"},"color":"none","bold":false}]

tag @a remove control_panel

#---------------------------------- Misc  -------------------------------------------#

tellraw @a[tag=clear_chat] ["",{"text":"\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"}]
tag @a[tag=clear_chat] remove clear_chat


tag @a remove give


